ST_GDALDrivers
Prev | 12.2. Raster Management | Next

## Name

ST_GDALDrivers — Returns a list of raster formats supported by PostGIS through GDAL. Only those formats with can_write=True can be used by ST_AsGDALRaster

## Synopsis

`setof record ST_GDALDrivers(`integer OUT idx, text OUT short_name, text OUT long_name, text OUT can_read, text OUT can_write, text OUT create_options`)`;

## Description

Returns a list of raster formats short_name,long_name and creator options of each format supported by GDAL. Use the short_name as input in the `format` parameter of ST_AsGDALRaster. Options vary depending on what drivers your libgdal was compiled with. `create_options` returns an xml formatted set of CreationOptionList/Option consisting of name and optional `type`, `description` and set of `VALUE` for each creator option for the specific driver.

Changed: 2.5.0 - add can_read and can_write columns.

Changed: 2.0.6, 2.1.3 - by default no drivers are enabled, unless GUC or Environment variable gdal_enabled_drivers is set.

Availability: 2.0.0 - requires GDAL >= 1.6.0.

## Examples: List of Drivers

    SET postgis.gdal_enabled_drivers = 'ENABLE_ALL';
    SELECT short_name, long_name, can_write
    FROM st_gdaldrivers()
    ORDER BY short_name;

       short_name    |                          long_name                          | can_write
    -----------------+-------------------------------------------------------------+-----------
     AAIGrid         | Arc/Info ASCII Grid                                         | t
     ACE2            | ACE2                                                        | f
     ADRG            | ARC Digitized Raster Graphics                               | f
     AIG             | Arc/Info Binary Grid                                        | f
     AirSAR          | AirSAR Polarimetric Image                                   | f
     ARG             | Azavea Raster Grid format                                   | t
     BAG             | Bathymetry Attributed Grid                                  | f
     BIGGIF          | Graphics Interchange Format (.gif)                          | f
     BLX             | Magellan topo (.blx)                                        | t
     BMP             | MS Windows Device Independent Bitmap                        | f
     BSB             | Maptech BSB Nautical Charts                                 | f
     PAux            | PCI .aux Labelled                                           | f
     PCIDSK          | PCIDSK Database File                                        | f
     PCRaster        | PCRaster Raster File                                        | f
     PDF             | Geospatial PDF                                              | f
     PDS             | NASA Planetary Data System                                  | f
     PDS4            | NASA Planetary Data System 4                                | t
     PLMOSAIC        | Planet Labs Mosaics API                                     | f
     PLSCENES        | Planet Labs Scenes API                                      | f
     PNG             | Portable Network Graphics                                   | t
     PNM             | Portable Pixmap Format (netpbm)                             | f
     PRF             | Racurs PHOTOMOD PRF                                         | f
     R               | R Object Data Store                                         | t
     Rasterlite      | Rasterlite                                                  | t
     RDA             | DigitalGlobe Raster Data Access driver                      | f
     RIK             | Swedish Grid RIK (.rik)                                     | f
     RMF             | Raster Matrix Format                                        | f
     ROI_PAC         | ROI_PAC raster                                              | f
     RPFTOC          | Raster Product Format TOC format                            | f
     RRASTER         | R Raster                                                    | f
     RS2             | RadarSat 2 XML Product                                      | f
     RST             | Idrisi Raster A.1                                           | t
     SAFE            | Sentinel-1 SAR SAFE Product                                 | f
     SAGA            | SAGA GIS Binary Grid (.sdat, .sg-grd-z)                     | t
     SAR_CEOS        | CEOS SAR Image                                              | f
     SDTS            | SDTS Raster                                                 | f
     SENTINEL2       | Sentinel 2                                                  | f
     SGI             | SGI Image File Format 1.0                                   | f
     SNODAS          | Snow Data Assimilation System                               | f
     SRP             | Standard Raster Product (ASRP/USRP)                         | f
     SRTMHGT         | SRTMHGT File Format                                         | t
     Terragen        | Terragen heightfield                                        | f
     TIL             | EarthWatch .TIL                                             | f
     TSX             | TerraSAR-X Product                                          | f
     USGSDEM         | USGS Optional ASCII DEM (and CDED)                          | t
     VICAR           | MIPL VICAR file                                             | f
     VRT             | Virtual Raster                                              | t
     WCS             | OGC Web Coverage Service                                    | f
     WMS             | OGC Web Map Service                                         | t
     WMTS            | OGC Web Map Tile Service                                    | t
     XPM             | X11 PixMap Format                                           | t
     XYZ             | ASCII Gridded XYZ                                           | t
     ZMap            | ZMap Plus Grid                                              | t

## Example: List of options for each driver

    -- Output the create options XML column of JPEG as a table  --
    -- Note you can use these creator options in ST_AsGDALRaster options argument
    SELECT (xpath('@name', g.opt))[1]::text As oname,
           (xpath('@type', g.opt))[1]::text As otype,
           (xpath('@description', g.opt))[1]::text As descrip
    FROM (SELECT unnest(xpath('/CreationOptionList/Option', create_options::xml)) As opt
    FROM  st_gdaldrivers()
    WHERE short_name = 'JPEG') As g;

           oname        |  otype  |      descrip
    --------------------+---------+-------------------------------------------------
     PROGRESSIVE        | boolean | whether to generate a progressive JPEG
     QUALITY            | int     | good=100, bad=0, default=75
     WORLDFILE          | boolean | whether to geneate a worldfile
     INTERNAL_MASK      | boolean | whether to generate a validity mask
     COMMENT            | string  | Comment
     SOURCE_ICC_PROFILE | string  | ICC profile encoded in Base64
     EXIF_THUMBNAIL     | boolean | whether to generate an EXIF thumbnail(overview).
                                    By default its max dimension will be 128
     THUMBNAIL_WIDTH    | int     | Forced thumbnail width
     THUMBNAIL_HEIGHT   | int     | Forced thumbnail height
    (9 rows)

    -- raw xml output for creator options for GeoTiff --
    SELECT create_options
    FROM st_gdaldrivers()
    WHERE short_name = 'GTiff';

    <CreationOptionList>
        <Option name="COMPRESS" type="string-select">
            <Value>NONE</Value>
            <Value>LZW</Value>
            <Value>PACKBITS</Value>
            <Value>JPEG</Value>
            <Value>CCITTRLE</Value>
            <Value>CCITTFAX3</Value>
            <Value>CCITTFAX4</Value>
            <Value>DEFLATE</Value>
        </Option>
        <Option name="PREDICTOR" type="int" description="Predictor Type"/>
        <Option name="JPEG_QUALITY" type="int" description="JPEG quality 1-100" default="75"/>
        <Option name="ZLEVEL" type="int" description="DEFLATE compression level 1-9" default="6"/>
        <Option name="NBITS" type="int" description="BITS for sub-byte files (1-7), sub-uint16 (9-15), sub-uint32 (17-31)"/>
        <Option name="INTERLEAVE" type="string-select" default="PIXEL">
            <Value>BAND</Value>
            <Value>PIXEL</Value>
        </Option>
        <Option name="TILED" type="boolean" description="Switch to tiled format"/>
        <Option name="TFW" type="boolean" description="Write out world file"/>
        <Option name="RPB" type="boolean" description="Write out .RPB (RPC) file"/>
        <Option name="BLOCKXSIZE" type="int" description="Tile Width"/>
        <Option name="BLOCKYSIZE" type="int" description="Tile/Strip Height"/>
        <Option name="PHOTOMETRIC" type="string-select">
            <Value>MINISBLACK</Value>
            <Value>MINISWHITE</Value>
            <Value>PALETTE</Value>
            <Value>RGB</Value>
            <Value>CMYK</Value>
            <Value>YCBCR</Value>
            <Value>CIELAB</Value>
            <Value>ICCLAB</Value>
            <Value>ITULAB</Value>
        </Option>
        <Option name="SPARSE_OK" type="boolean" description="Can newly created files have missing blocks?" default="FALSE"/>
        <Option name="ALPHA" type="boolean" description="Mark first extrasample as being alpha"/>
        <Option name="PROFILE" type="string-select" default="GDALGeoTIFF">
            <Value>GDALGeoTIFF</Value>
            <Value>GeoTIFF</Value>
            <Value>BASELINE</Value>
        </Option>
        <Option name="PIXELTYPE" type="string-select">
            <Value>DEFAULT</Value>
            <Value>SIGNEDBYTE</Value>
        </Option>
        <Option name="BIGTIFF" type="string-select" description="Force creation of BigTIFF file">
            <Value>YES</Value>
            <Value>NO</Value>
            <Value>IF_NEEDED</Value>
            <Value>IF_SAFER</Value>
        </Option>
        <Option name="ENDIANNESS" type="string-select" default="NATIVE" description="Force endianness of created file. For DEBUG purpose mostly">
            <Value>NATIVE</Value>
            <Value>INVERTED</Value>
            <Value>LITTLE</Value>
            <Value>BIG</Value>
        </Option>
        <Option name="COPY_SRC_OVERVIEWS" type="boolean" default="NO" description="Force copy of overviews of source dataset (CreateCopy())"/>
    </CreationOptionList>

    -- Output the create options XML column for GTiff as a table  --
    SELECT (xpath('@name', g.opt))[1]::text As oname,
           (xpath('@type', g.opt))[1]::text As otype,
           (xpath('@description', g.opt))[1]::text As descrip,
           array_to_string(xpath('Value/text()', g.opt),', ') As vals
    FROM (SELECT unnest(xpath('/CreationOptionList/Option', create_options::xml)) As opt
    FROM  st_gdaldrivers()
    WHERE short_name = 'GTiff') As g;

           oname        |     otype     |                               descrip                                |                                   vals
    --------------------+---------------+----------------------------------------------------------------------+---------------------------------------------------------------------------
     COMPRESS           | string-select |                                                                      | NONE, LZW, PACKBITS, JPEG, CCITTRLE, CCITTFAX3, CCITTFAX4, DEFLATE
     PREDICTOR          | int           | Predictor Type                                                       |
     JPEG_QUALITY       | int           | JPEG quality 1-100                                                   |
     ZLEVEL             | int           | DEFLATE compression level 1-9                                        |
     NBITS              | int           | BITS for sub-byte files (1-7), sub-uint16 (9-15), sub-uint32 (17-31) |
     INTERLEAVE         | string-select |                                                                      | BAND, PIXEL
     TILED              | boolean       | Switch to tiled format                                               |
     TFW                | boolean       | Write out world file                                                 |
     RPB                | boolean       | Write out .RPB (RPC) file                                            |
     BLOCKXSIZE         | int           | Tile Width                                                           |
     BLOCKYSIZE         | int           | Tile/Strip Height                                                    |
     PHOTOMETRIC        | string-select |                                                                      | MINISBLACK, MINISWHITE, PALETTE, RGB, CMYK, YCBCR, CIELAB, ICCLAB, ITULAB
     SPARSE_OK          | boolean       | Can newly created files have missing blocks?                         |
     ALPHA              | boolean       | Mark first extrasample as being alpha                                |
     PROFILE            | string-select |                                                                      | GDALGeoTIFF, GeoTIFF, BASELINE
     PIXELTYPE          | string-select |                                                                      | DEFAULT, SIGNEDBYTE
     BIGTIFF            | string-select | Force creation of BigTIFF file                                       | YES, NO, IF_NEEDED, IF_SAFER
     ENDIANNESS         | string-select | Force endianness of created file. For DEBUG purpose mostly           | NATIVE, INVERTED, LITTLE, BIG
     COPY_SRC_OVERVIEWS | boolean       | Force copy of overviews of source dataset (CreateCopy())             |
    (19 rows)

## See Also

ST_AsGDALRaster, ST_SRID, postgis.gdal_enabled_drivers

Prev | Up | Next
PostGIS_Raster_Lib_Version | Home | ST_Contour